<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;

class StockhistoryModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "stockhistory";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "stockhistory";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "transaksi", "noTransaksi", "itemId", "kapalId", "lokasiId", 
        "jumlah", "lotNumber", "username", "mutasi", "date_updated",
        "stokawal", "sisaawal", "sisaakhir", "periode", "stokawal_periode", "harga", "harga_satuan"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "stockhistory.id",
        "namaItem" => "itemId.namaItem",
        "deskripsi" => "itemId.deskripsi",
        "part_number" => "itemId.part_number",
        "namaLokasi" => "lokasiId.namaLokasi",
        "expense_account" => "itemId.expense_account",
        "jumlah" => "stockhistory.jumlah",
        "lokasiId" => "stockhistory.lokasiId",
        "type" => "stockhistory.type",
        "lotNumber" => "stockhistory.lotNumber"
    ];

    /**
     * relation from ' . item . ' by ' . itemId
     * join item on item.id = stockhistory.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItemId($alias = "itemId")
    {
        $this->getQuery()->join("item as $alias", function ($join) use ($alias) {
			$join->on("$alias.id", "=", "stockhistory.itemId");
			$join->on("$alias.kapalId", "=", "stockhistory.kapalId");
        })
        ->join("itemcategory as itemCategory", "itemCategory.id", "=", $alias.".type_id");
        return $this;
    }

    /**
     * relation from ' . kapal . ' by ' . kapalId
     * join kapal on kapal.id = stockhistory.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationKapalId($alias = "kapalId")
    {
        $this->getQuery()->join("kapal as $alias", "$alias.id", "=", "stockhistory.kapalId");
        return $this;
    }

    /**
     * relation from ' . lokasiitem . ' by ' . lokasiId
     * join lokasiitem on lokasiitem.id = stockhistory.lokasiId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationLokasiId($alias = "lokasiId")
    {
        $this->getQuery()->join("lokasiitem as $alias", function ($join) use ($alias) {
			$join->on("$alias.id", "=", "stockhistory.lokasiId");
		});
        return $this;
    }

    public function joinRelationPenggunaanBarang($alias = "penggunaanBarang")
    {
        $this->getQuery()->join("penggunaanbarang as $alias", "$alias.miNumber", "=", "stockhistory.noTransaksi");
        return $this;
    }

    public function joinRelationItemPenggunaanBarang($alias = "itemPenggunaanBarang")
    {
        $this->getQuery()->join("itempenggunaanbarang as $alias", function($join) use($alias) {
            $join->on("$alias.id", "=", "stockhistory.noTransaksi");
            $join->on("$alias.itemId", "=", "stockhistory.itemId");
            $join->on("$alias.lotNumber", "=", "stockhistory.lotNumber");
        });
        return $this;
    }

    public function mapperOracle($oracle)
    {
        $this->id;
        $this->itemId;
        $this->kapalId;
        $this->lokasiId;
        $this->jumlah;
        $this->satuan;
        $this->status;
        $this->type;
        $this->date_updated;
        $this->lotNumber;
        $this->tglMasuk;
    }
}